## dtkwidget 5.6.11

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

set(VERSION
    "5.6.8"
    CACHE STRING "define project version"
)

project(DtkWidget
    VERSION ${VERSION}
    DESCRIPTION "DTK Widget module"
    HOMEPAGE_URL "https://github.com/linuxdeepin/dtkwidget"
    LANGUAGES CXX C
)

set(LIB_NAME dtkwidget)

# Set install path
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif()

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
if(UNIX AND NOT APPLE)
    set(LINUX TRUE)
endif()

# Set build option
set(BUILD_PLUGINS
    ON
    CACHE BOOL "Build plugin and plugin example"
)

set(INCLUDE_INSTALL_DIR
    "${CMAKE_INSTALL_INCLUDEDIR}/dtk${PROJECT_VERSION_MAJOR}/DWidget"
)
set(TOOL_INSTALL_DIR
    "${CMAKE_INSTALL_LIBDIR}/dtk${PROJECT_VERSION_MAJOR}/DWidget/bin"
)
set(LIBRARY_INSTALL_DIR
    "${CMAKE_INSTALL_LIBDIR}"
)
set(MKSPECS_INSTALL_DIR
    "${CMAKE_INSTALL_LIBDIR}/qt5/mkspecs/modules"
    CACHE STRING "Install dir for qt pri files"
)
set(CONFIG_INSTALL_DIR
    "${CMAKE_INSTALL_LIBDIR}/cmake/DtkWidget"
    CACHE STRING "Install directory for cmake files"
)
set(PKGCONFIG_INSTALL_DIR
    "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
    CACHE STRING "Install directory for pkgconfig files"
)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(BUILD_TESTING ON)
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")
endif()
# find_package
find_package(Dtk REQUIRED COMPONENTS Core Gui)
find_package(QT NAMES Qt5 REQUIRED COMPONENTS Core)
find_package(Qt5 REQUIRED COMPONENTS
    Core
    Network
    Concurrent
    Widgets
    PrintSupport
    LinguistTools
    X11Extras
    DBus
)
find_package(PkgConfig REQUIRED)

file(GLOB D_HEADERS "${PROJECT_SOURCE_DIR}/include/DWidget/*")

set(AUTOCONFIG ${CMAKE_CURRENT_BINARY_DIR}/dtkwidget_config.h)
get_filename_component(CONFIG_INCLUDE ${AUTOCONFIG} DIRECTORY)
set(CONFIG_CONTENT)
string(APPEND CONFIG_CONTENT "// This is an auto-generated config\n")

foreach(header ${D_HEADERS})
    get_filename_component(thename ${header} NAME)
    string(APPEND CONFIG_CONTENT "#define DTKWIDGET_CLASS_${thename}\n")
endforeach()

file(WRITE ${AUTOCONFIG} ${CONFIG_CONTENT})

file(GLOB_RECURSE PUBLIC_HEADERS "${PROJECT_SOURCE_DIR}/include/*.h")
list(APPEND PUBLIC_HEADERS ${D_HEADERS} ${AUTOCONFIG})

add_subdirectory(src)
add_subdirectory(examples)
add_subdirectory(tools)

if(BUILD_TESTING)
    message("==================================")
    message("      Now Testing is enabled      ")
    message("==================================")
    enable_testing()
    add_subdirectory(tests)
endif()

if(BUILD_PLUGINS)
    message("===================================")
    message(" You can build and run plugins now ")
    message("===================================")
    add_subdirectory(plugin)
endif()

set(BUILD_DOCS
    OFF
    CACHE BOOL "Generate doxygen-based documentation"
)

if(BUILD_DOCS)
    message("===================================")
    message("     You can build docs  now       ")
    message("===================================")
    add_subdirectory(docs)
endif()

configure_package_config_file(
    misc/DtkWidgetConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/DtkWidgetConfig.cmake
    INSTALL_DESTINATION ${CONFIG_INSTALL_DIR}
    PATH_VARS TOOL_INSTALL_DIR
)

write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/DtkWidgetConfigVersion.cmake
    VERSION ${VERSION}
    COMPATIBILITY SameMajorVersion
)
install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/DtkWidgetConfig.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/DtkWidgetConfigVersion.cmake
    DESTINATION ${CONFIG_INSTALL_DIR}
)

configure_file(misc/dtkwidget.pc.in dtkwidget.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dtkwidget.pc DESTINATION ${PKGCONFIG_INSTALL_DIR})

configure_file(misc/qt_lib_dtkwidget.pri.in qt_lib_dtkwidget.pri @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qt_lib_dtkwidget.pri DESTINATION ${MKSPECS_INSTALL_DIR})

=== docs/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

find_package (Doxygen REQUIRED)

set (QCH_INSTALL_DESTINATION ${CMAKE_INSTALLL_PREFIX}/share/qt5/doc CACHE STRING "QCH install location")

set (DOXYGEN_GENERATE_HTML "YES" CACHE STRING "Doxygen HTML output")
set (DOXYGEN_GENERATE_XML "YES" CACHE STRING "Doxygen XML output")
set (DOXYGEN_GENERATE_QHP "YES" CACHE STRING "Doxygen QHP output")
set (DOXYGEN_FILE_PATTERNS *.cpp *.h *.zh_CN.md *.zh_CN.dox CACHE STRING "Doxygen File Patterns")
set (DOXYGEN_PROJECT_NUMBER ${CMAKE_PROJECT_VERSION} CACHE STRING "") # Should be the same as this project is using.
set (DOXYGEN_EXTRACT_STATIC YES)
set (DOXYGEN_OUTPUT_LANGUAGE "Chinese" CACHE STRING "Doxygen Output Language")
set (DOXYGEN_IMAGE_PATH ${CMAKE_CURRENT_LIST_DIR}/images/)
set (DOXYGEN_QHG_LOCATION "qhelpgenerator")
set (DOXYGEN_QHP_NAMESPACE "org.deepin.dtk.widget")
set (DOXYGEN_QCH_FILE "dtkwidget.qch")
set (DOXYGEN_QHP_VIRTUAL_FOLDER "dtkwidget")
set (DOXYGEN_HTML_EXTRA_STYLESHEET "" CACHE STRING "Doxygen custom stylesheet for HTML output")
set (DOXYGEN_TAGFILES "qtcore.tags=qthelp://org.qt-project.qtcore/qtcore/" CACHE STRING "Doxygen tag files")

set (DOXYGEN_PREDEFINED
    "D_DECL_DEPRECATED_X(x)="
    "DCORE_BEGIN_NAMESPACE=namespace Dtk { namespace Core {"
    "DCORE_END_NAMESPACE=}}"
    "DCORE_USE_NAMESPACE=using namespace Dtk::Core;"
    "DWIDGET_BEGIN_NAMESPACE=namespace Dtk { namespace Widget {"
    "DWIDGET_END_NAMESPACE=}}"
    "DWIDGET_USE_NAMESPACE=using namespace Dtk::Widget;"
)

set (BUILD_THEME OFF CACHE BOOL "Build doxgen theme")
if(BUILD_THEME)
if(EXISTS "${CMAKE_CURRENT_LIST_DIR}/doxygen-theme")
message(STATUS "doxygen-theme exist")
else()
execute_process(COMMAND git clone https://github.com/linuxdeepin/doxygen-theme.git --depth=1
        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
        TIMEOUT 60
    )
execute_process(COMMAND bash themesetting.sh
        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/doxygen-theme/
)
endif()
set (DOXYGEN_HTML_EXTRA_STYLESHEET "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome.css"
                                "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-sidebar-only.css"
                                "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-sidebar-only-darkmode-toggle.css"
                                )
set (DOXYGEN_HTML_EXTRA_FILES "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-darkmode-toggle.js"
                            "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-fragment-copy-button.js"
                            "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-paragraph-link.js"
                            "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-interactive-toc.js"
                            )
set (DOXYGEN_GENERATE_TREEVIEW "YES")
set (DOXYGEN_DISABLE_INDEX "NO")
set (DOXYGEN_FULL_SIDEBAR "NO")
set (DOXYGEN_HTML_HEADER "docs/doxygen-theme/doxygen-awesome-css/header.html")
set (DOXYGEN_HTML_FOOTER "docs/doxygen-theme/doxygen-awesome-css/footer.html")
endif()

set (DOXYGEN_MACRO_EXPANSION "YES")
set (DOXYGEN_EXPAND_ONLY_PREDEF "YES")

# Exclude private classes.
set(DOXYGEN_EXCLUDE_PATTERNS
    ${PROJECT_SOURCE_DIR}/src/widgets/private/dimageviewer_p.h
    ${PROJECT_SOURCE_DIR}/src/widgets/private/dimagevieweritems_p.h
    ${PROJECT_SOURCE_DIR}/src/widgets/dimagevieweritems.cpp
)

doxygen_add_docs (doxygen
    ${PROJECT_SOURCE_DIR}/src
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/docs
    ALL
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    COMMENT "Generate documentation via Doxygen"
)

install (FILES ${PROJECT_BINARY_DIR}/docs/html/dtkwidget.qch DESTINATION ${QCH_INSTALL_DESTINATION})

=== src/CMakeLists.txt ===
pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt)
pkg_check_modules(XcbUtil REQUIRED IMPORTED_TARGET xcb-util)
pkg_check_modules(StartupNotification REQUIRED IMPORTED_TARGET libstartup-notification-1.0)
pkg_check_modules(Xext REQUIRED IMPORTED_TARGET xext)
pkg_check_modules(Xi REQUIRED IMPORTED_TARGET xi)
pkg_check_modules(X11 REQUIRED IMPORTED_TARGET x11)

include(util/util.cmake)
include(widgets/widgets.cmake)

file(GLOB TRANSLATIONS translations/*.ts)
qt5_add_translation(QM_FILES ${TRANSLATIONS})

add_library(${LIB_NAME} SHARED
    ${WIDGETS}
    ${QM_FILES}
    ${UTIL}
    ${PUBLIC_HEADERS}
)

set(TRANSLATIONS_INSTALL_DIR
    "dtk${PROJECT_VERSION_MAJOR}/DWidget/translations"
)

target_compile_definitions(${LIB_NAME} PRIVATE
    SN_API_NOT_YET_FROZEN
    DTK_NO_MULTIMEDIA
    DWIDGET_TRANSLATIONS_DIR="${TRANSLATIONS_INSTALL_DIR}"
    LIBDTKWIDGET_LIBRARY
)

if(DTK_STATIC_TRANSLATION)
target_compile_definitions(${LIB_NAME} PRIVATE
    DTK_STATIC_TRANSLATION
)
endif()

target_include_directories(${LIB_NAME}
PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/DWidget>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/util>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/widgets>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/global>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${CONFIG_INCLUDE}>
INTERFACE
    $<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR}>
)

target_link_libraries(${LIB_NAME}
PUBLIC
    Qt5::Widgets
    Qt5::Network
    Qt5::Core
    Qt5::DBus
    Qt5::PrintSupport
    Dtk::Gui
    Dtk::Core
PRIVATE
    Qt5::Concurrent
    Qt5::X11Extras
    Qt5::GuiPrivate
    Qt5::WidgetsPrivate
    Qt5::PrintSupportPrivate
    PkgConfig::QGSettings
    PkgConfig::StartupNotification
    PkgConfig::Xext
    PkgConfig::Xi
    PkgConfig::X11
    PkgConfig::XcbUtil
)

target_link_directories(${LIB_NAME} INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${LIBRARY_INSTALL_DIR}>
)

set_target_properties(${LIB_NAME}
    PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    EXPORT_NAME Widget
    PUBLIC_HEADER "${PUBLIC_HEADERS}"
)
install(
    TARGETS ${LIB_NAME}
    EXPORT DtkWidgetTargets
    DESTINATION ${LIBRARY_INSTALL_DIR}
    PUBLIC_HEADER DESTINATION ${INCLUDE_INSTALL_DIR}
)

install(
    EXPORT DtkWidgetTargets
    FILE DtkWidgetTargets.cmake
    NAMESPACE Dtk::
    DESTINATION ${CONFIG_INSTALL_DIR}
)

install(FILES ${QM_FILES} DESTINATION "${CMAKE_INSTALL_DATADIR}/${TRANSLATIONS_INSTALL_DIR}")

dconfig_meta_files(COMMONID org.deepin.dtkwidget FILES ${CMAKE_CURRENT_LIST_DIR}/org.deepin.dtkwidget.feature-display.json)

=== tests/CMakeLists.txt ===
set(BIN_NAME "ut-${LIB_NAME}")

find_package(Qt5 REQUIRED COMPONENTS Test)
find_package(GTest REQUIRED)

pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt)
pkg_check_modules(XcbUtil REQUIRED IMPORTED_TARGET xcb-util)
pkg_check_modules(StartupNotification REQUIRED IMPORTED_TARGET libstartup-notification-1.0)
pkg_check_modules(Xext REQUIRED IMPORTED_TARGET xext)
pkg_check_modules(Xi REQUIRED IMPORTED_TARGET xi)
pkg_check_modules(X11 REQUIRED IMPORTED_TARGET x11)

set(WIDGET_TEST 
    testcases/widgets/ut_daboutdialog.cpp
    testcases/widgets/ut_dabstractdialog.cpp
    testcases/widgets/ut_dalertcontrol.cpp
    testcases/widgets/ut_danchor.cpp
    # TODO break the test
    #testcases/widgets/ut_danchors.cpp
    testcases/widgets/ut_darrowbutton.cpp
    testcases/widgets/ut_darrowlinedrawer.cpp
    testcases/widgets/ut_darrowlineexpand.cpp
    testcases/widgets/ut_darrowrectangle.cpp
    testcases/widgets/ut_dbackgroundgroup.cpp
    testcases/widgets/ut_dbaseexpand.cpp
    testcases/widgets/ut_dbaseline.cpp
    testcases/widgets/ut_dblureffectwidget.cpp
    testcases/widgets/ut_dboxwidget.cpp
    testcases/widgets/ut_dbuttonbox.cpp
    testcases/widgets/ut_dcircleprogress.cpp
    testcases/widgets/ut_dclipeffectwidget.cpp
    testcases/widgets/ut_dcoloredprogressbar.cpp
    testcases/widgets/ut_dcommandlinkbutton.cpp
    testcases/widgets/ut_dcrumbedit.cpp
    testcases/widgets/ut_ddialog.cpp
    testcases/widgets/ut_ddialogclosebutton.cpp
    testcases/widgets/ut_ddrawer.cpp
    testcases/widgets/ut_ddrawergroup.cpp
    testcases/widgets/ut_denhancedwidget.cpp
    # TODO test break
    #testcases/widgets/ut_dexpandgroup.cpp
    testcases/widgets/ut_dfilechooseredit.cpp
    testcases/widgets/ut_dfiledialog.cpp
    testcases/widgets/ut_dfloatingbutton.cpp
    testcases/widgets/ut_dfloatingmessage.cpp
    testcases/widgets/ut_dfloatingwidget.cpp
    # TODO break
    # testcases/widgets/ut_dflowlayout.cpp
    testcases/widgets/ut_dframe.cpp
    testcases/widgets/ut_dgraphicsclipeffect.cpp
    testcases/widgets/ut_dgraphicsgloweffect.cpp
    testcases/widgets/ut_dheaderline.cpp
    testcases/widgets/ut_diconbutton.cpp
    testcases/widgets/ut_dimageviewer.cpp
    testcases/widgets/ut_dinputdialog.cpp
    testcases/widgets/ut_dipv4lineedit.cpp
    testcases/widgets/ut_dkeysequenceedit.cpp
    testcases/widgets/ut_dlabel.cpp
    testcases/widgets/ut_dlineedit.cpp
    testcases/widgets/ut_dlistview.cpp
    testcases/widgets/ut_dloadingindicator.cpp
    testcases/widgets/ut_dmainwindow.cpp
    testcases/widgets/ut_dmessagemanager.cpp
    testcases/widgets/ut_dmpriscontrol.cpp
    testcases/widgets/ut_dpageindicator.cpp
    testcases/widgets/ut_dpasswordedit.cpp
    testcases/widgets/ut_dpicturesequenceview.cpp
    # TODO PREAK
    #testcases/widgets/ut_dprintpickcolorwidget.cpp
    #testcases/widgets/ut_dprintpreviewdialog.cpp
    testcases/widgets/ut_dprintpreviewwidget.cpp
    testcases/widgets/ut_dprogressbar.cpp
    testcases/widgets/ut_dpushbutton.cpp
    #TODO BREAK kf.windowsystem: Could not find any platform plugin
    # testcases/widgets/ut_dsearchcombobox.cpp
    testcases/widgets/ut_dsearchedit.cpp
    testcases/widgets/ut_dsettingsdialog.cpp
    testcases/widgets/ut_dsettingswidgetfactory.cpp
    testcases/widgets/ut_dshaowline.cpp
    testcases/widgets/ut_dsimplelistview.cpp
    testcases/widgets/ut_dslider.cpp
    # TODO break
    #testcases/widgets/ut_dspinbox.cpp
    # testcases/widgets/ut_dspinner.cpp
    testcases/widgets/ut_dstackwidget.cpp
    testcases/widgets/ut_dstyleditemdelegate.cpp
    testcases/widgets/ut_dstyleoption.cpp
    testcases/widgets/ut_dsuggestbutton.cpp
    testcases/widgets/ut_dswitchbutton.cpp
    testcases/widgets/ut_dtabbar.cpp
    testcases/widgets/ut_dtextedit.cpp
    testcases/widgets/ut_dtickeffect.cpp
    testcases/widgets/ut_dtiplabel.cpp
    testcases/widgets/ut_dtitlebar.cpp
    testcases/widgets/ut_dtoolbutton.cpp
    testcases/widgets/ut_dtooltip.cpp
    testcases/widgets/ut_dwarningbutton.cpp
    # FIXME break
    # testcases/widgets/ut_dwaterprogress.cpp
    testcases/widgets/ut_dwindowclosebutton.cpp
    testcases/widgets/ut_dwindowmaxbutton.cpp
    testcases/widgets/ut_dwindowminbutton.cpp
    testcases/widgets/ut_dwindowoptionbutton.cpp
    testcases/widgets/ut_dwindowquitfullbutton.cpp
)

include(${PROJECT_SOURCE_DIR}/src/util/util.cmake)
include(${PROJECT_SOURCE_DIR}/src/widgets/widgets.cmake)

set(RESCOUCES data.qrc)

add_executable(${BIN_NAME}
    main.cpp
    ${UTIL}
    ${WIDGETS}
    ${WIDGET_TEST}
    ${PUBLIC_HEADERS}
)

target_compile_definitions(${BIN_NAME} PRIVATE
    SN_API_NOT_YET_FROZEN
    DTK_NO_MULTIMEDIA
    DWIDGET_TRANSLATIONS_DIR="dtk${PROJECT_VERSION_MAJOR}/DWidget/translations"
)

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    target_compile_options(${BIN_NAME} PRIVATE -fprofile-instr-generate -ftest-coverage)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(${BIN_NAME} PRIVATE -fprofile-arcs -ftest-coverage)
endif()

target_compile_options(${BIN_NAME} PRIVATE -fno-access-control -fsanitize=address)
target_link_options(${BIN_NAME} PRIVATE -fsanitize=address)

target_include_directories(${BIN_NAME} PRIVATE
    ${PROJECT_SOURCE_DIR}/src/widgets
    ${PROJECT_SOURCE_DIR}/include/DWidget
    ${PROJECT_SOURCE_DIR}/include/util
    ${PROJECT_SOURCE_DIR}/include/widgets
    ${PROJECT_SOURCE_DIR}/include/global
    ${PROJECT_SOURCE_DIR}/include
    ${CONFIG_INCLUDE}
)

target_link_libraries(${BIN_NAME} PRIVATE 
    Qt5::Test
    Qt5::Widgets
    Qt5::WidgetsPrivate
    Qt5::Core
    Qt5::GuiPrivate
    Qt5::DBus
    Qt5::PrintSupport
    Qt5::PrintSupportPrivate
    Qt5::Concurrent
    Qt5::X11Extras
    Qt5::Network
    PkgConfig::QGSettings
    PkgConfig::StartupNotification
    PkgConfig::Xext
    PkgConfig::Xi
    PkgConfig::X11
    PkgConfig::XcbUtil
    Dtk::Gui
    Dtk::Core
    GTest::GTest
    gmock
    pthread
    m
    gcov
)

add_test(NAME ${BIN_NAME} COMMAND ${BIN_NAME})

=== examples/PrintPreviewSettingsPlugin/CMakeLists.txt ===
set(PLUGIN_NAME PrintPreviewSettingsPlugin)

find_package(Qt5 REQUIRED COMPONENTS Core)

add_library(${PLUGIN_NAME} SHARED 
  settingsplugin.h 
  settingsplugin.cpp
)

target_link_libraries(${PLUGIN_NAME} PRIVATE 
  ${LIB_NAME}
)

=== examples/collections/CMakeLists.txt ===
set(BIN_NAME collections)
set(CMAKE_AUTOUIC ON)

find_package(Qt5 REQUIRED COMPONENTS Gui Widgets)

add_executable(${BIN_NAME}
    images.qrc
    resources.qrc
    icons/theme-icons.qrc
    cameraform.ui
    mainwindow.h
    buttonexample.h
    examplewindowinterface.h
    pagewindowinterface.h
    editexample.h
    sliderexample.h
    listviewexample.h
    windowexample.h
    tooltipexample.h
    spinnerexample.h
    dialogexample.h
    progressbarexample.h
    layoutexample.h
    scrollbarexample.h
    rubberbandexample.h
    widgetexample.h
    lcdnumberexample.h
    menuexample.h
    imageviewerexample.h
    main.cpp
    mainwindow.cpp
    buttonexample.cpp
    examplewindowinterface.cpp
    pagewindowinterface.cpp
    editexample.cpp
    sliderexample.cpp
    listviewexample.cpp
    windowexample.cpp
    tooltipexample.cpp
    spinnerexample.cpp
    dialogexample.cpp
    progressbarexample.cpp
    layoutexample.cpp
    scrollbarexample.cpp
    rubberbandexample.cpp
    widgetexample.cpp
    lcdnumberexample.cpp
    menuexample.cpp
    imageviewerexample.cpp
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt5::Widgets
    Qt5::GuiPrivate
    ${LIB_NAME}
)
install(
    TARGETS ${BIN_NAME}
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/dtk${PROJECT_VERSION_MAJOR}/DWidget/examples/"
)

dconfig_override_files(APPID dtk-example META_NAME org.deepin.dtkwidget.feature-display FILES ${CMAKE_CURRENT_LIST_DIR}/org.deepin.dtkwidget.feature-display.json)

=== plugin/dtkuidemo/CMakeLists.txt ===
set(DEMO dtkuidemo)

set(CMAKE_AUTOUIC ON)

# We must find Qt5Widgets explicitly to include Qt5::uic target for AUTOUIC, although Qt5::Widgets is implicitly linked to demo through dtkwidget
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui Widgets)

add_executable(
    ${DEMO}
    main.cpp
    mainwindow.h
    mainwindow.cpp
    dtkuidemo.qrc
    mainwindow.ui
)

target_link_libraries(${DEMO} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::GuiPrivate
    ${LIB_NAME}
)

=== plugin/dtkuiplugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

set(UIPLUGIN dtkuiplugin)
project(${UIPLUGIN} VERSION 1.0.0 LANGUAGES CXX)

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS UiPlugin Gui)

set(LIB_DWIDGET ${LIB_NAME})

if (CMAKE_PROJECT_NAME STREQUAL ${UIPLUGIN})
    message("compile ${UIPLUGIN} individually")
    set(CMAKE_INCLUDE_CURRENT_DIR ON)
    set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
    set(CMAKE_AUTOMOC ON)
    set(CMAKE_AUTORCC ON)
    set(CMAKE_CXX_STANDARD 11)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
    include(GNUInstallDirs)
    if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
        set(CMAKE_INSTALL_PREFIX /usr)
    endif()
    find_package(DtkWidget REQUIRED)
    set(LIB_DWIDGET Dtk::Widget)
endif()

add_library(
    ${UIPLUGIN} SHARED
    dcustomerplugins.h
    dcustomerplugins.cpp
    dcustomermacrowidget.h
    dtkuiplugin.qrc
)

target_link_libraries(
    ${UIPLUGIN} PRIVATE
    ${LIB_DWIDGET}
    Qt${QT_VERSION_MAJOR}::UiPlugin
    Qt${QT_VERSION_MAJOR}::GuiPrivate
)

set(INSTALL_PLUGIN OFF CACHE BOOL "Install dtk designer plugin")
if(INSTALL_PLUGIN)
    set(QT_PLUGIN_DESIGNER_PATH "qt5/plugins/designer")
    install(TARGETS ${UIPLUGIN} DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}/${QT_PLUGIN_DESIGNER_PATH}")
    message(STATUS "Install path:" "${CMAKE_INSTALL_FULL_LIBDIR}/${QT_PLUGIN_DESIGNER_PATH}")
endif()

=== tools/svgc/CMakeLists.txt ===
set(BIN_NAME dtk-svgc)

find_package(Dtk REQUIRED COMPONENTS Gui)
find_package(Qt5 REQUIRED COMPONENTS Svg)

add_executable(
    ${BIN_NAME}
    main.cpp
)

target_link_libraries(
    ${BIN_NAME} PRIVATE
    Qt5::Svg
    Dtk::Gui
)

install(TARGETS ${BIN_NAME} DESTINATION "${TOOL_INSTALL_DIR}")

=== debian/changelog ===
dtkwidget (5.6.11) unstable; urgency=medium

  * Release 5.6.11
  * FIX dtk#51 dtk#62 dtk#36
  * FIX bug-195913 DArrowRectangle postion calc error

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 08 May 2023 13:35:05 +0800

dtkwidget (5.6.10) unstable; urgency=medium

  * Release 5.6.10
  * FIX #364 #373 #389 #390 #403 #408
  * FIX Build error for Qt 5.15~6.1
  * FIX DFloatingButton can't display dci icon

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 17 Apr 2023 17:14:10 +0800

dtkwidget (5.6.9) unstable; urgency=medium

  * Release 5.6.9

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 03 Apr 2023 10:13:53 +0800

dtkwidget (5.6.8) unstable; urgency=medium

  * Release 5.6.8

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 22 Feb 2023 14:21:55 +0800

dtkwidget (5.6.7) unstable; urgency=medium

  * Release 5.6.7

 -- Deepin Packages Builder <packages@deepin.com>  Fri, 17 Feb 2023 13:13:24 +0800

dtkwidget (5.6.6) unstable; urgency=medium

  * Release 5.6.6 update with broken dtkcore
  * Update doc, for danchors
  * fix the broken case if open the popup window second time

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 06 Feb 2023 17:22:10 +0800

dtkwidget (5.6.5) unstable; urgency=medium

  * Release 5.6.5

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 02 Feb 2023 14:15:00 +0800

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
export QT_SELECT = qt5

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

VERSION = $(DEB_VERSION_UPSTREAM)
_PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')
_BUILD_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$2}' | sed 's/[^0-9]//g' | awk '{print int($$1)}')
ifeq ($(_BUILD_VER),)
	CONFIG_VERSION = $(_PACK_VER)
else
	CONFIG_VERSION = $(_PACK_VER).$(_BUILD_VER)
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_PLUGINS=OFF -DBUILD_DOCS=ON -DVERSION=$(_PACK_VER)
#override_dh_auto_configure:
#	dh_auto_configure -- LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)
#override_dh_makeshlibs:
#	dh_makeshlibs -V

#ifeq ($(DEB_BUILD_ARCH), sw_64)
#override_dh_makeshlibs:
#	dh_makeshlibs -V -- -c0
#endif

override_dh_makeshlibs:
	dh_makeshlibs  -V "libdtkwidget5 (>= $(shell echo $(VERSION) | cut -d '.' -f 1,2))"

## dtkwidget 5.6.12

=== docs/CMakeLists.txt ===
--- 
+++ 
@@ -65,6 +65,7 @@
 set(DOXYGEN_EXCLUDE_PATTERNS
     ${PROJECT_SOURCE_DIR}/src/widgets/private/dimageviewer_p.h
     ${PROJECT_SOURCE_DIR}/src/widgets/private/dimagevieweritems_p.h
+    ${PROJECT_SOURCE_DIR}/src/widgets/private/dsplitscreen_p.h
     ${PROJECT_SOURCE_DIR}/src/widgets/dimagevieweritems.cpp
 )

=== debian/changelog ===
dtkwidget (5.6.12-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 10 Oct 2023 15:06:47 +0800

dtkwidget (5.6.12) unstable; urgency=medium

  * Release 5.6.12
  * add DLicenseDialog

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 15 May 2023 11:28:59 +0800

=== debian/control ===
Source: dtkwidget
Section: libdevel
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: debhelper-compat (= 12), pkg-config, libudev-dev,
 libqt5x11extras5-dev, libxext-dev, qttools5-dev-tools, qttools5-dev,
 x11proto-xext-dev, libxcb-util0-dev, libstartup-notification0-dev,
 libmtdev-dev, qtbase5-private-dev, libegl1-mesa-dev, libudev-dev,
 libfontconfig1-dev, libfreetype6-dev, libglib2.0-dev, libxrender-dev,
 libdtkcore-dev, libgsettings-qt-dev, libqt5svg5-dev, libxi-dev,
 libdtkgui-dev, libcups2-dev, libgtest-dev, libdtkcore5-bin, cmake, doxygen
Standards-Version: 3.9.8

Package: libdtkwidget5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdtkcommon,
  libqt5widgets5(>= 5.11.3.33) | libqt5widgets5(<= 5.11.3.28)
Multi-Arch: same
Description: Deepin graphical user interface library
 DtkWidget is Deepin graphical user interface for deepin desktop development.
 .
 This package contains the shared libraries.

Package: libdtkwidget5-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libdtkwidget5( =${binary:Version}),
 libqt5x11extras5-dev, libdtkcore-dev, libqt5svg5-dev
Description: Deepin graphical user interface library utilities
 DtkWidget is Deepin graphical user interface for deepin desktop development.
 .
 This package contains the utilities which are
 needed for developing Deepin applications.

Package: libdtkwidget-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libdtkwidget5( =${binary:Version}),
 libqt5x11extras5-dev, libdtkcore-dev, libqt5svg5-dev,
 libdtkgui-dev, libcups2-dev
Description: Deepin graphical user interface library
 DtkWidget is Deepin graphical user interface for deepin desktop development.
 .
 This package contains the header files and static libraries which are
 needed for developing Deepin applications.

Package: dtkwidget5-examples
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libdtkwidget5( =${binary:Version})
Description: dtkwidget-examples is generated by dtkwidget.
 DtkWidget is Deepin graphical user interface for deepin desktop development.
 .
 This package contains example application which are
 needed for developing Deepin applications.

Package: dtkwidget-doc
Architecture: any
Description: Deepin graphical user interface library (Document)
 DtkWidget is Deepin graphical user interface for deepin desktop development.
 .
 This package contains example application which are
 needed for developing Deepin applications.

## dtkwidget 5.6.32

=== src/CMakeLists.txt ===
if("${QT_VERSION_MAJOR}" STREQUAL "5")
    pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt) #Dtk6 removed.
endif()
pkg_check_modules(XcbUtil REQUIRED IMPORTED_TARGET xcb-util)
pkg_check_modules(StartupNotification REQUIRED IMPORTED_TARGET libstartup-notification-1.0)
pkg_check_modules(Xext REQUIRED IMPORTED_TARGET xext)
pkg_check_modules(Xi REQUIRED IMPORTED_TARGET xi)
pkg_check_modules(X11 REQUIRED IMPORTED_TARGET x11)

include(util/util.cmake)
include(widgets/widgets.cmake)

file(GLOB TRANSLATIONS translations/*.ts)
if("${QT_VERSION_MAJOR}" STREQUAL "5")
    qt5_add_translation(QM_FILES ${TRANSLATIONS})
else()
    qt6_add_translation(QM_FILES ${TRANSLATIONS})
endif()

add_library(${LIBNAME} SHARED
    ${WIDGETS}
    ${QM_FILES}
    ${UTIL}
    ${PUBLIC_HEADERS}
)

set(TRANSLATIONS_INSTALL_DIR
    "dtk${PROJECT_VERSION_MAJOR}/DWidget/translations"
)

target_compile_definitions(${LIBNAME} PRIVATE
    SN_API_NOT_YET_FROZEN
    DTK_NO_MULTIMEDIA
    DWIDGET_TRANSLATIONS_DIR="${TRANSLATIONS_INSTALL_DIR}"
    LIBDTKWIDGET_LIBRARY
)

if(DTK_STATIC_TRANSLATION)
target_compile_definitions(${LIBNAME} PRIVATE
    DTK_STATIC_TRANSLATION
)
endif()

target_include_directories(${LIBNAME}
PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/DWidget>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/util>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/widgets>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/global>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${CONFIG_INCLUDE}>
INTERFACE
    $<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR}>
)

target_link_libraries(${LIBNAME}
PUBLIC
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::Network
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    Qt${QT_VERSION_MAJOR}::PrintSupport
    Dtk${DTK_VERSION_MAJOR}::Gui
    Dtk${DTK_VERSION_MAJOR}::Core
PRIVATE
    Qt${QT_VERSION_MAJOR}::Concurrent
    Qt${QT_VERSION_MAJOR}::GuiPrivate
    Qt${QT_VERSION_MAJOR}::WidgetsPrivate
    Qt${QT_VERSION_MAJOR}::PrintSupportPrivate
    PkgConfig::StartupNotification
    PkgConfig::Xext
    PkgConfig::Xi
    PkgConfig::X11
    PkgConfig::XcbUtil
)

if("${QT_VERSION_MAJOR}" STREQUAL "5")
    target_link_libraries(${LIBNAME} PRIVATE
        PkgConfig::QGSettings
        Qt5::X11Extras
    )
endif()

target_link_directories(${LIBNAME} INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${LIBRARY_INSTALL_DIR}>
)

set_target_properties(${LIBNAME}
    PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    EXPORT_NAME Widget
    PUBLIC_HEADER "${PUBLIC_HEADERS}"
)
install(
    TARGETS ${LIBNAME}
    EXPORT ${DtkWidget}Targets
    DESTINATION ${LIBRARY_INSTALL_DIR}
    PUBLIC_HEADER DESTINATION ${INCLUDE_INSTALL_DIR}
)

install(
    EXPORT ${DtkWidget}Targets 
    NAMESPACE Dtk${DTK_VERSION_MAJOR}:: 
    FILE ${DtkWidget}Targets.cmake 
    DESTINATION "${CONFIG_CMAKE_INSTALL_DIR}"
)

install(FILES ${QM_FILES} DESTINATION "${CMAKE_INSTALL_DATADIR}/${TRANSLATIONS_INSTALL_DIR}")

=== debian/changelog ===
dtkwidget (5.6.32) unstable; urgency=medium

  * fix: DMessageManager::sendMessage cause crash
    Thanks to zty199
  * fix: wrong product icon size in DAboutDialog
    Thanks to zty199
  * fix: DTitleBar动态设置Icon时间距异常

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 08 Jul 2024 02:29:21 +0000

dtkwidget (5.6.31) unstable; urgency=medium

  [ root ]
  * UNRELEASED

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 27 Jun 2024 09:11:34 +0000

dtkwidget (5.6.30) unstable; urgency=medium

  * feat: modify the spacing between the title and the top(Issue: https://github.com/linuxdeepin/developer-center/issues/8418)
  * fix: 解决wayland下，DDialog窗口透明问题的问题 (#578)
    Thanks to Cjq(Bug: 249975)(Influence: wayland下，DDialog窗口模糊)

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 30 May 2024 02:46:31 +0000

dtkwidget (5.6.29) unstable; urgency=medium

  * fix: 修复大多数按钮不响应enter事件(Bug: 253935)(Influence: 按钮响应键盘回车事件)
  * revert: "fix: 自定义页码切换问题"(Issue: https://github.com/linuxdeepin/developer-center/issues/7983)
  * fix: support build on qt 6.7

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 13 May 2024 03:02:55 +0000

dtkwidget (5.6.28) unstable; urgency=medium

  * fix: window menu icon(Issue: https://github.com/linuxdeepin/developer-center/issues/8297)

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 29 Apr 2024 08:23:39 +0000

dtkwidget (5.6.27) unstable; urgency=medium

  * chore: disable broken workflow build
  * fix: next action rect position error(Issue: https://github.com/linuxdeepin/developer-center/issues/6379)
  * fix: fix the problem of text position in dstyleditemdelegate(issue: 7673)
  * fix: Split window position error(Issue: https://github.com/linuxdeepin/developer-center/issues/4840)

 -- Deepin Packages Builder <packages@deepin.org>  Fri, 19 Apr 2024 08:55:35 +0000

dtkwidget (5.6.26) unstable; urgency=medium

  * chore: 调整标题栏“更多/最小化/最大化/关闭按钮”的图标为最新1070图标样式(Task: 331465)(Influence: 窗口标题栏 更多/最小化/最大化/关闭按钮)
  * feat: don't hide alert message automatically.(Issue: https://github.com/linuxdeepin/developer-center/issues/5622)

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 26 Mar 2024 05:47:35 +0000

dtkwidget (5.6.25) unstable; urgency=medium

  * chore: 调整关于对话框界面布局和样式(Task: 303535)(Influence: 关于对话框)
  * fix: 调整关于对话框链接颜色(Task: 303535)(Influence: 关于对话框链接颜色)
  * fix: 修复关于对话框在应用名称很长时内容有被截断的情况(Bug: 240835)(Influence: 关于对话框布局)
  * fix: 修复dslider刻度标签内容过长时，显示不下的问题(Task: 325247)(Influence: DSlider刻度标签显示)
  * fix: dconfig frequent construction and destruction
  * fix: black circle in PasswordEdit(Issue: https://github.com/linuxdeepin/developer-center/issues/7335)
  * chore: Adapt to Qt 6.6.1
  * Revert "fix: black circle in PasswordEdit"
  * fix: black circle in PasswordLineEdit(Issue: https://github.com/linuxdeepin/developer-center/issues/7335)

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 11 Mar 2024 01:16:27 +0000

dtkwidget (5.6.23) unstable; urgency=medium

  * release 5.6.23

 -- Mike Chen <chenke@deepin.org>  Wed, 31 Jan 2024 09:29:11 +0800

dtkwidget (5.6.22) unstable; urgency=medium

  * fix: double click edit incorrect format(Issue: https://github.com/linuxdeepin/developer-center/issues/6780)
  * chore: remove unused headers in header

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 10 Jan 2024 02:30:59 +0000

dtkwidget (5.6.21) unstable; urgency=medium

  * chore: nullptr check in dstyleditemdelegate
  * chore: logical judgment errors

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 09 Jan 2024 01:45:43 +0000

dtkwidget (5.6.20) unstable; urgency=medium

  * feat: styleHint tweak
  * chore: add synchronization workflow
  * fix: redefinition of verticalTabs
  * fix: export inexistent classes in config
  * fix: 修复DLicenseDialog内存泄漏(Influence: DLicenseDialog)
  * fix: DArrowRectangle left/right style incorrect(Issue: #92)
  * fix: DApplication初始化过程中会覆盖原有事件掩码，导致丢失事件(Bug: 220369)
  * feat: move ddesktopservices to dtkgui(Issue: #134)

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 28 Nov 2023 05:40:53 +0000

dtkwidget (5.6.19) unstable; urgency=medium

  * feat: change DTK_STATIC_TRANSLATION to the default setting.
    Thanks to He Xin

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 23 Oct 2023 07:33:18 +0000

dtkwidget (5.6.18) unstable; urgency=medium

  * fix: ColorMode may be inconsistent with settings.(Bug: 219201)(Influence: PrintPreview)
  * chore: correct typos about action slots
    Thanks to Felix Yan
  * feat: use DIconTheme::findQIcon(Issue: #4112)
  * fix: 修复打印预览，切换打印机的时候预览图颜色显示异常
    Thanks to zhangkun(Bug: 220315)(Influence: 打印预览切换打印机时预览图的颜色表现)
  * doc: update docs for denhancedwidget
    Thanks to syn(Issue: #94)

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 18 Oct 2023 06:01:44 +0000

dtkwidget (5.6.17) unstable; urgency=medium

  * Release 5.6.17

 -- Deepin Packages Builder <packages@deepin.org>  Fri, 08 Sep 2023 15:19:50 +0800

dtkwidget (5.6.16) unstable; urgency=medium

  * feat: add ut_dpalettehelper
  * chore: add test for dwatermarkhelper
  * fix: update dependency libfreetype-dev

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 22 Aug 2023 06:13:44 +0000

dtkwidget (5.6.15) unstable; urgency=medium

  * chore: remove useless files
  * feat: Add UT for DComboBox
  * doc: update docs for dfontcombobox 更新dfontcombobox的文档
    Thanks to LyYeeeYuwu(Issue: #94)
  * doc: update docs for dtooltip
    Thanks to syn(Issue: #94)
  * doc: update docs for dcircleprogress
    Thanks to homehome(Issue: #94)
  * doc: update docs for dcrumbedit
    Thanks to LyYeeeYuwu(Issue: #94)

 -- Yixue Wang <wangyixue@deepin.org>  Fri, 11 Aug 2023 14:03:59 +0800

dtkwidget (5.6.14) unstable; urgency=medium

  * fix: Button background lightness display error(Issue: #82)
  * doc: update docs for dpasswordedit
    Thanks to homehome(Task: 26)
  * doc: update docs for dtabbar
    Thanks to homehome(Issue: #94)
  * refactor!: deprecate some interfaces in dtk6
  * doc: update docs for dcombobox


## dtkwidget 5.7.5

=== debian/changelog ===
dtkwidget (5.7.5) unstable; urgency=medium

  * fix: webengineView abnormal in DMainWindow

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 12 Dec 2024 03:03:54 +0000

dtkwidget (5.7.4) unstable; urgency=medium

  * fix: ddialog's lambda func may cause segfault
  * fix: some windows have dual title bars

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 03 Dec 2024 02:00:46 +0000

dtkwidget (5.7.3) unstable; urgency=medium

  [ root ]
  * UNRELEASED

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 20 Nov 2024 02:19:06 +0000

dtkwidget (5.7.2) unstable; urgency=medium

  [ root ]
  * UNRELEASED

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 13 Nov 2024 01:53:26 +0000

dtkwidget (5.7.1) unstable; urgency=medium

  * fix: 如果窗口打开时即为最大化状态,则最大化图标显示错误 (#601)
    Thanks to Whale107(Bug: 262201)(Influence: mainwindow最大化)
  * feat: support treeland notitlebar mode
  * chore: 新增进度条动效和一个新进度条类 (#589)
    Thanks to Whale107
  * chore: 新增搜索框图标移动动画 (#590)
    Thanks to Whale107
  * fix: adjust indeterminateprogressbar color (#597)
    Thanks to Whale107
  * chore: 增加滚动区域滚轮滚动到顶部或底部的回弹效果 (#596)
    Thanks to Whale107
  * chore: 增加ButtonBox hover 和切换动画 (#595)
    Thanks to Whale107
  * chore: 使用dci icon重绘toolbutton, 增加动画 (#594)
    Thanks to Whale107
  * chore: 使用dci icon重绘switchButton, 增加动画 (#593)
    Thanks to Whale107
  * chore: 增加应用内通知动画 (#592)
    Thanks to Whale107
  * fix: adjust switchbutton dci icon (#603)
    Thanks to Whale107
  * Revert "chore: 使用dci icon重绘toolbutton, 增加动画 (#594)"
  * fix: obsolete interfaces
  * fix: display exception of checkbox & radiobutton(Bug: 276189)
  * fix: wrong status of switch button(Bug: 276221)

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 16 Oct 2024 03:30:46 +0000

dtkwidget (5.6.34) unstable; urgency=medium

  [ root ]
  * UNRELEASED

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 21 Aug 2024 09:47:27 +0000

dtkwidget (5.6.33) unstable; urgency=medium

  * fix: DMessageManager::sendMessage cause crash
    Thanks to zty199
  * fix: wrong product icon size in DAboutDialog
    Thanks to zty199
  * fix: DTitleBar动态设置Icon时间距异常
  * fix: 控制中心标题栏返回按钮消失 (#588)
    Thanks to Whale107(Bug: 264379)(Influence: 控制中心-标题栏)

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 20 Aug 2024 03:30:08 +0000

## dtkwidget 5.7.9

=== debian/changelog ===
dtkwidget (5.7.9-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Tue, 11 Feb 2025 15:24:02 -0500

dtkwidget (5.7.9-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/control: Update build-dep packages.
  * debian/patches: Dropped, now useless.
  * debian/libdtkwidget5.shlibs: Tighten version requirement.

 -- Boyuan Yang <byang@debian.org>  Mon, 10 Feb 2025 21:11:21 -0500

=== debian/control ===
Source: dtkwidget
Section: libs
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
 Yanhao Mo <yanhaocs@gmail.com>,
 SZ Lin (林上智) <szlin@debian.org>,
 Arun Kumar Pariyar <arun@debian.org>,
 Hu Feng <hufeng@uniontech.com>,
 Clay Stan <claystan97@gmail.com>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libcups2-dev,
 libdframeworkdbus-dev (>= 6),
 libdtkcore-dev (>= 5.7.9~),
 libdtkcore5-bin (>= 5.7.9~),
 libdtkgui-dev (>= 5.7.9~),
 libegl1-mesa-dev,
 libfontconfig-dev,
 libfreetype-dev,
 libglib2.0-dev,
 libgsettings-qt-dev,
 libgtest-dev,
 libmtdev-dev,
 libqt5svg5-dev,
 libqt5x11extras5-dev,
 libstartup-notification0-dev,
 libudev-dev,
 libxcb-util-dev,
 libxext-dev,
 libxi-dev,
 libxrender-dev,
 pkgconf,
 qtbase5-private-dev,
 qttools5-dev,
 qttools5-dev-tools,
 x11proto-xext-dev,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://github.com/linuxdeepin/dtkwidget
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/dtkwidget.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/dtkwidget

Package: dtkwidget5-examples
Architecture: any
Depends:
 libdtkwidget5 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: dtkwidget-examples is generated by dtkwidget
 DtkWidget is Deepin graphical user interface for deepin desktop development.
 .
 This package contains example application which are
 needed for developing Deepin applications.

Package: libdtkwidget-dev
Architecture: any
Section: libdevel
Depends:
 libcups2-dev,
 libdtkcore-dev (>= 5.7.8),
 libdtkgui-dev (>= 5.7.8),
 libdtkwidget5 (= ${binary:Version}),
 libqt5svg5-dev,
 libqt5x11extras5-dev,
 ${misc:Depends},
Multi-Arch: same
Description: Deepin Tool Kit Widget library (development files)
 DtkWidget is the Deepin graphical user interface library for deepin
 desktop development.
 .
 This package is part of DDE (Deepin Desktop Environment).
 .
 This package contains the header files and static libraries which are
 needed for developing Deepin application.

Package: libdtkwidget5
Architecture: any
Depends:
 libdtkcommon,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 dde-qt5integration,
Multi-Arch: same
Description: Deepin Tool Kit Widget library
 DtkWidget is the Deepin graphical user interface library for deepin
 desktop development.
 .
 This package is part of DDE (Deepin Desktop Environment).
 .
 This package contains the shared libraries.

Package: libdtkwidget5-bin
Architecture: any
Depends:
 libdtkcore-dev (>= 5.7.8),
 libdtkwidget5 (= ${binary:Version}),
 libqt5svg5-dev,
 libqt5x11extras5-dev,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Deepin Tool Kit Widget library utilities
 DtkWidget is the Deepin graphical user interface library for deepin
 desktop development.
 .
 This package is part of DDE (Deepin Desktop Environment).
 .
 This package contains the utilities which are needed for developing
 Deepin applications.

## dtkwidget 5.7.11

=== debian/changelog ===
dtkwidget (5.7.11-2) unstable; urgency=medium

  * debian/control: Add missing build-dep on libdtklog-dev.

 -- Boyuan Yang <byang@debian.org>  Mon, 03 Mar 2025 10:31:32 -0500

dtkwidget (5.7.11-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sun, 02 Mar 2025 13:48:24 -0500

=== debian/control ===
--- 
+++ 
@@ -14,9 +14,10 @@
  cmake,
  libcups2-dev,
  libdframeworkdbus-dev (>= 6),
- libdtkcore-dev (>= 5.7.9~),
- libdtkcore5-bin (>= 5.7.9~),
- libdtkgui-dev (>= 5.7.9~),
+ libdtkcore-dev (>= 5.7.11~),
+ libdtkcore5-bin (>= 5.7.11~),
+ libdtkgui-dev (>= 5.7.11~),
+ libdtklog-dev,
  libegl1-mesa-dev,
  libfontconfig-dev,
  libfreetype-dev,
@@ -38,7 +39,7 @@
  qttools5-dev-tools,
  x11proto-xext-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/linuxdeepin/dtkwidget
 Vcs-Git: https://salsa.debian.org/pkg-deepin-team/dtkwidget.git
 Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/dtkwidget
@@ -60,8 +61,9 @@
 Section: libdevel
 Depends:
  libcups2-dev,
- libdtkcore-dev (>= 5.7.8),
- libdtkgui-dev (>= 5.7.8),
+ libdtkcore-dev (>= 5.7.11),
+ libdtkgui-dev (>= 5.7.11),
+ libdtklog-dev,
  libdtkwidget5 (= ${binary:Version}),
  libqt5svg5-dev,
  libqt5x11extras5-dev,
@@ -96,7 +98,6 @@
 Package: libdtkwidget5-bin
 Architecture: any
 Depends:
- libdtkcore-dev (>= 5.7.8),
  libdtkwidget5 (= ${binary:Version}),
  libqt5svg5-dev,
  libqt5x11extras5-dev,

## dtkwidget 5.7.12

=== tools/CMakeLists.txt ===
add_subdirectory(svgc)

=== tools/svgc/CMakeLists.txt ===
set(TARGET_NAME dtk-svgc)
set(BIN_NAME ${TARGET_NAME}${DTK_VERSION_MAJOR})

find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Gui)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Svg)

add_executable(
    ${BIN_NAME}
    main.cpp
)

target_link_libraries(
    ${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Svg
    Dtk${DTK_VERSION_MAJOR}::Gui
)

install(TARGETS ${BIN_NAME} DESTINATION "${TOOL_INSTALL_DIR}")

=== debian/changelog ===
dtkwidget (5.7.12-1build1) questing; urgency=medium

  * No-change rebuild against Qt 5.15.17.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Tue, 15 Jul 2025 13:04:05 +0300

dtkwidget (5.7.12-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sun, 16 Mar 2025 15:59:33 -0400

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export QT_SELECT := 5

# Explicitly enable hardening
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Retrieve version info
include /usr/share/dpkg/default.mk



%:
	dh $@

# TODO: enable doc build (qch)
override_dh_auto_configure:
	dh_auto_configure -- \
            -DBUILD_PLUGINS=OFF \
            -DBUILD_DOCS=OFF \
            -DDTK_VERSION=$(DEB_VERSION_UPSTREAM) \
            $(NULL)

## dtkwidget 5.7.14

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

set(DTK_VERSION
    "5.6.12"
    CACHE STRING "define project version"
)

project(DtkWidget
    VERSION ${DTK_VERSION}
    DESCRIPTION "DTK Widget module"
    HOMEPAGE_URL "https://github.com/linuxdeepin/dtkwidget"
    LANGUAGES CXX C
)

# Set install path
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif()

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

if("${PROJECT_VERSION_MAJOR}" STREQUAL "5")
    set(QT_VERSION_MAJOR 5)
    include(dtkwidget.cmake)
elseif("${PROJECT_VERSION_MAJOR}" STREQUAL "6")
    set(QT_VERSION_MAJOR "6")
    set(DTK_VERSION_MAJOR "6")
    include(dtkwidget.cmake)
else()
    message(SEND_ERROR "not support Prject Version ${PROJECT_VERSION}.")
endif()

=== debian/changelog ===
dtkwidget (5.7.14) unstable; urgency=medium

  * fix: wheel event is accepted in qt6
  * fix: 修复SwitchButton在透明窗口上显示时颜色太亮,太突兀的问题
  * fix: DToolTip宽度计算
  * fix: DFloatingMessage宽度计算

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 17 Apr 2025 21:51:46 +0800

dtkwidget (5.7.13) unstable; urgency=medium

  * fix: accessing wild pointer for DAboutDialog
  * feat: increase fallback for password character

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 20 Mar 2025 17:06:12 +0800

dtkwidget (5.7.12) unstable; urgency=medium

  * fix: failed to save too long filename for DPrintPreviewWidget
  * chore: remove warning in qt6
  * feat: Add files generated by qdbusXML2cpp and DCONG2cpp
  * doc: update docs for dwatermarkhelper

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 06 Mar 2025 17:29:50 +0800

dtkwidget (5.7.11) unstable; urgency=medium

  * fix: window filickering caused by animation for DDrawer
  * fix: app crashed for DBlurEffectWidget in qt6
  * fix: titlebar can't drag after close DAboutDialog
  * fix: PrintPreview can't switch orientation

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 27 Feb 2025 20:47:56 +0800

dtkwidget (5.7.10) unstable; urgency=medium

  * fix: 修复 桌面/文管文件，打开属性窗口闪烁

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 13 Feb 2025 17:18:34 +0800

dtkwidget (5.7.9) unstable; urgency=medium

  * fix: missing QT_QPA_PLATFORM for DApplication

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 23 Jan 2025 09:07:09 +0000

dtkwidget (5.7.8) unstable; urgency=medium

  * fix: access wild pointer for targetWindowHandle

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 14 Jan 2025 11:17:32 +0000

dtkwidget (5.7.7) unstable; urgency=medium

  [ root ]
  * UNRELEASED

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 09 Jan 2025 09:28:39 +0000

dtkwidget (5.7.6) unstable; urgency=medium

  * fix: resident floating message cannot be closed(Bug: 297669)
  * fix: 调整滑动条横条和刻度颜色(Bug: 254295)(Influence: 调整滑动条横条和刻度颜色)

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 02 Jan 2025 05:43:53 +0000

## dtkwidget 5.7.16

=== debian/changelog ===
dtkwidget (5.7.16) unstable; urgency=medium

  * Release 5.7.16

 -- YeShanShan <yeshanshan@uniontech.com>  Mon, 19 May 2025 17:22:07 +0800

dtkwidget (5.7.15) unstable; urgency=medium

  * fix: correct text elision behavior with shortcuts
  * style: adjust website link style in about dialog
  * chore: reuse warning
  * fix: watermark can't select picture for PrintPreivew
  * build: compiling failed with Qt 6.9
  * chore: bump version to 5.7.14

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 08 May 2025 17:53:16 +0800
